-- description: \n       |VV| King the Memer |VV|\n       |__|  - ReRemake -  |__|\n\nPeach's letter was accidentally sent\nto King's address and without thinking\nhe went to the castle trying to return\nit. little did he know he would need to\nspend all day gathering Stars to save\nsomeone he doesn't even know.\n\nMOD BY:            L + Y: Toggle King\nking the memer            Z: Ball Form\n\n   [CS] supported but NOT required\n  /kskin [name] to swap loaded skins
-- name: |^| King the Memer - ReRemake

-- save flags
SAVE_FLAG_TALKED_TO_KING = 1 << 21

-- sounds
SOUND_KING_BOUNCE = SOUND_ARG_LOAD(SOUND_BANK_OBJ,     0x64, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)
SOUND_KING_CHARGE = SOUND_ARG_LOAD(SOUND_BANK_ACTION,  0x5E, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)
SOUND_KING_DASH =   SOUND_ARG_LOAD(SOUND_BANK_OBJ,     0x01, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)
SOUND_KING_JUMP =   SOUND_ARG_LOAD(SOUND_BANK_OBJ,     0x4C, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)
SOUND_KING_BOING =  SOUND_ARG_LOAD(SOUND_BANK_GENERAL, 0x6D, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)
SOUND_KING_SWIM =   SOUND_ARG_LOAD(SOUND_BANK_ACTION,  0x47, 0x80, SOUND_NO_PRIORITY_LOSS | SOUND_DISCRETE)

-- samples
SAMPLE_KING =        audio_sample_load("king.ogg")
SAMPLE_END_CAKE =    audio_sample_load("end_cake.ogg")
SAMPLE_YOSHI_TJUMP = audio_sample_load("yoshi_tjump.ogg")

-- actions
ACT_KING_WALKING =      allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_FIRST_PERSON)
ACT_KING_BALL_AIR =     allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_AIR)
ACT_KING_BALL_LAND =    allocate_mario_action(ACT_GROUP_STATIONARY | ACT_FLAG_STATIONARY | ACT_FLAG_ATTACKING)
ACT_KING_BOUNCE =       allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_AIR)
ACT_KING_BOUNCE_LAND =  allocate_mario_action(ACT_GROUP_STATIONARY | ACT_FLAG_STATIONARY | ACT_FLAG_ATTACKING)
ACT_KING_ROLLING =      allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE | ACT_FLAG_SHORT_HITBOX)
ACT_KING_ROLLDASH =     allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE | ACT_FLAG_SHORT_HITBOX)
ACT_KING_FLOAT =        allocate_mario_action(ACT_GROUP_SUBMERGED | ACT_FLAG_MOVING | ACT_FLAG_METAL_WATER | ACT_FLAG_SWIMMING_OR_FLYING | ACT_FLAG_WATER_OR_TEXT)
ACT_KING_SPECIAL_BALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING | ACT_FLAG_AIR)
ACT_KING_POLE_SPIN =    allocate_mario_action(ACT_GROUP_AUTOMATIC | ACT_FLAG_STATIONARY | ACT_FLAG_ON_POLE)
ACT_KING_POLE_JUMP =    allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

-- textures
TEX_KING = get_texture_info("king.icon_king")

-- models
E_MODEL_KING =       smlua_model_util_get_id("king_geo")
E_MODEL_KING_BALL =  smlua_model_util_get_id("king_ball_geo")
E_MODEL_SPINBALL =   smlua_model_util_get_id("king_spinball_geo")
E_MODEL_KING_ALONE = smlua_model_util_get_id("king_alone_geo")

-- skins
KSKIN_KING = {
    ["name"] = "King",
    ["desc"] = "Standing at 1'0' King doesn't seem like much and although he's not very fast on foot, when he curls up into a ball and starts bouncing around, nothing can stop the little guy.",
    ["credit"] = "king the memer",
    ["icon"] = TEX_KING,
    ["pal"] = {
        [PANTS]  = {r =  77, g =  33, b = 151},
        [SHIRT]  = {r = 126, g = 103, b = 236},
        [GLOVES] = {r = 255, g = 255, b = 255},
        [SHOES]  = {r = 126, g = 103, b = 236},
        [HAIR]   = {r = 115, g =   6, b =   0},
        [SKIN]   = {r = 254, g = 193, b = 121},
        [CAP]    = {r = 126, g = 103, b = 236},
        [EMBLEM] = {r = 255, g = 255, b = 255}
    },

    ["model"] = {
        ["main"] = E_MODEL_KING,
        ["ball"] = E_MODEL_KING_BALL
    },

    ["sfx"] = SAMPLE_KING,
}

kSkins = {
    ["king"] = KSKIN_KING
}

function _G.add_king_kskin(cmdName, skin)
    table.insert(kSkins, cmdName)
    kSkins[cmdName] = skin
end

hook_chat_command("kskin", "Changes King's skin", function(msg)
    local m = gMarioStates[0]
    local k = gKingStates[0]

    if msg == "" then
        return false
    end

    msg = string.lower(msg)

    if kSkins[msg] ~= nil then
        k.kSkin = kSkins[msg]
        djui_chat_message_create("kSkin successfully changed to "..k.kSkin.name)

        play_sound(SOUND_GENERAL_LEVEL_SELECT_CHANGE, m.marioObj.header.gfx.cameraToObject)
        play_character_sound(m, CHAR_SOUND_OKEY_DOKEY)
    else
        djui_chat_message_create("Unrecognized skin")
        play_sound(SOUND_MENU_CAMERA_BUZZ, m.marioObj.header.gfx.cameraToObject)
    end

    return true
end)

-- custom variables
_G.gKingStates = {}
for i = 0, (MAX_PLAYERS - 1) do
    gKingStates[i] = {
        ["saveForwardVel"] = 0,
        ["saveTimer"] = 0,
        ["saveYpos"] = 0,
        ["savevel"] = {
            ["x"] = 0,
            ["y"] = 0,
            ["z"] = 0
        },

        ["rdCharge"] = 50,
        ["float"] = 0, -- float as in water float not 0.5f
        ["rollYvel"] = 0,
        ["bowserAngleVel"] = 0,
        ["jumpTimer"] = 0,
        ["punchSound"] = 0,
        ["rDashAngle"] = 0,
        ["cheatKoopa"] = 0,
        ["djumped"] = 0,

        ["starKing"] = {
            ["enabled"] = 0,
            ["timer"] = 0,
            ["closeToStar"] = false
        },

        ["kSkin"] = KSKIN_KING,

        ["canBreak"] = false,
        ["isRomHack"] = false
    }

    gPlayerSyncTable[i].isKing = true

    for _, mod in pairs(gActiveMods) do
        if mod.incompatible == "romhack"
        or mod.name == "GORE / Hard-Mode!" then
            gKingStates[i].isRomHack = true
        end
    end
end

function hypot(x, y)
    return math.sqrt(x^2 + y^2)
end

function convert_s16(num)
    local min = -2^15
    local max = 2^15 - 1
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end

function convert_s32(num)
    local min = -2^31
    local max = 2^31 - 1
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end

if charSelectExists then
    CS_KING = charSelect.character_add(KSKIN_KING.name, KSKIN_KING.desc, KSKIN_KING.credit,
    KSKIN_KING.pal[SHIRT], KSKIN_KING.model.main, nil, KSKIN_KING.icon, 1, 0)
end

function mario_update(m)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]
    local idleAction = ((m.action & ACT_FLAG_PAUSE_EXIT) ~= 0 and (m.action & ACT_FLAG_ALLOW_FIRST_PERSON) ~= 0) or (m.action & ACT_FLAG_IDLE) ~= 0

    if gSync.isKing then
        if m.action == ACT_BURNING_GROUND then
            m.forwardVel = approach_f32_symmetric(m.forwardVel, 48, 2)
            m.marioObj.header.gfx.angle.x = -0x1000

            if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_RUNNING then
                smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_FIRE")
            end
        end

        if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SINGLE_JUMP then
            if m.vel.y > 0 then
                set_anim_to_frame(m, 0)
            end
            smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_JUMP")
        end

        if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_LAND_FROM_SINGLE_JUMP then
            smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_LAND")
        end

        if m.action == ACT_JUMBO_STAR_CUTSCENE or m.action == ACT_END_PEACH_CUTSCENE then
            if m.marioBodyState.capState == MARIO_HAS_WING_CAP_ON then
                m.marioBodyState.capState = MARIO_HAS_DEFAULT_CAP_ON
                m.marioBodyState.modelState = 0x400
            end
        end
    end

    if m.playerIndex == 0 then
        if charSelectExists == nil then
            if ((m.controller.buttonPressed & Y_BUTTON) ~= 0 and (m.controller.buttonDown & L_TRIG) ~= 0)
            or ((m.controller.buttonDown & Y_BUTTON) ~= 0 and (m.controller.buttonPressed & L_TRIG) ~= 0) then
                if idleAction then
                    gSync.isKing = not gSync.isKing

                    play_sound(SOUND_GENERAL_LEVEL_SELECT_CHANGE, m.marioObj.header.gfx.cameraToObject)
                    play_character_sound(m, CHAR_SOUND_OKEY_DOKEY)
                end
            end
        else
            gSync.isKing = false

            if charSelect.character_get_current_number() == CS_KING then
                gSync.isKing = true
            end
        end

        if gSync.isKing then
            -- MISC
            k.isBall = false

            if m.action == ACT_KING_ROLLDASH then
                if k.rdCharge == 200 or get_global_timer() % 4 == 0 then
                    gSync.modelId = k.kSkin.model.spinball or E_MODEL_SPINBALL
                else
                    gSync.modelId = k.kSkin.model.ball
                end
                k.isBall = true
            end

            if m.action == ACT_KING_BOUNCE or m.action == ACT_KING_BOUNCE_LAND then
                gSync.modelId = k.kSkin.model.spinball or E_MODEL_SPINBALL
                k.isBall = true
            end

            if m.action == ACT_KING_ROLLING or m.action == ACT_KING_BALL_LAND or m.action == ACT_KING_FLOAT
            or (m.action == ACT_KING_BALL_AIR and m.actionState == 0) or (m.action == ACT_FLYING and m.wallKickTimer ~= 0)
            or m.action == ACT_SHOT_FROM_CANNON then
                local ballSpeed = math.abs(hypot(m.forwardVel, m.vel.y))

                if ballSpeed > 64 and get_global_timer() % 4 == 0 then
                    gSync.modelId = k.kSkin.model.spinball or E_MODEL_SPINBALL
                else
                    gSync.modelId = k.kSkin.model.ball
                end
                k.isBall = true
            end

            gFirstPersonCamera.crouch = max(gFirstPersonCamera.crouch, 45)

            if k.isBall then
                gFirstPersonCamera.crouch = min(gFirstPersonCamera.crouch + 20, 70)
            else
                gSync.modelId = k.kSkin.model.main
            end

            k.canBreak = (k.isBall and m.forwardVel >= 128) or k.starKing.enabled == 1

            if charSelectExists then
                charSelect.character_edit(charSelect.character_get_current_number(), k.kSkin.name,
                k.kSkin.desc, k.kSkin.credit, k.kSkin.pal[CAP], gPlayerSyncTable[0].modelId)

                charSelect.character_add_palette_preset(gPlayerSyncTable[0].modelId, k.kSkin.pal)
            end

            -- MAIN
            if m.action == ACT_STEEP_JUMP then
                m.marioObj.header.gfx.angle.y = m.faceAngle.y
            end

            if m.action == ACT_THROWN_FORWARD then
                mario_set_forward_vel(m, math.abs(m.forwardVel))
            end

            if m.action == ACT_THROWN_FORWARD or m.action == ACT_GETTING_BLOWN or m.action == ACT_VERTICAL_WIND then
                m.marioObj.header.gfx.angle.x = convert_s16(get_global_timer() * 0x800)
                m.marioObj.header.gfx.angle.y = convert_s16(get_global_timer() * 0x800)

                m.marioBodyState.eyeState = 8
                m.marioBodyState.handState = MARIO_HAND_OPEN
                set_mario_animation(m, MARIO_ANIM_AIRBORNE_ON_STOMACH)
                set_anim_to_frame(m, get_global_timer() * 2 % m.marioObj.header.gfx.animInfo.curAnim.loopEnd)
            end

            if m.action == ACT_HOLD_WALKING then
                if mario_floor_is_steep(m) ~= 0 then
                    if m.floor.normal.y > 0.7 then
                        m.forwardVel = approach_f32_symmetric(m.forwardVel, 32, m.intendedMag / 8)
                    end
                else
                    m.forwardVel = approach_f32_symmetric(m.forwardVel, 32, m.intendedMag / 8)
                end
            end

            if m.action == ACT_DOUBLE_JUMP then
                local fuck = max(0x2000 - (m.actionTimer * 0x100), 0)

                m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y + (m.actionTimer * fuck)
                m.actionTimer = min(m.actionTimer + 1, 16)
            end

            if m.action == ACT_KING_ROLLDASH then
                m.marioObj.header.gfx.scale.x = 1 - (((k.rdCharge - 50) / 200) * 0.1)
                m.marioObj.header.gfx.scale.y = 1 + (((k.rdCharge - 50) / 200) * 0.5)
                m.marioObj.header.gfx.scale.z = 1 - (((k.rdCharge - 50) / 200) * 0.2)

                m.marioObj.header.gfx.angle.x = ((k.rdCharge - 50) / 100) * 0x1000
            else
                k.rDashAngle = m.faceAngle.y
                k.rdCharge = 0
            end

            if m.action == ACT_KING_BALL_AIR then
                m.marioObj.header.gfx.scale.x = 1 - m.actionTimer / 32
                m.marioObj.header.gfx.scale.y = 1 + m.actionTimer / 32
                m.marioObj.header.gfx.scale.z = 1 - m.actionTimer / 32

                if m.actionState == 0 then
                    update_air_memer(m, 2)
                end
            end

            if m.action == ACT_KING_BOUNCE then
                m.marioObj.header.gfx.scale.x = 1 - min(math.abs(m.vel.y), 100) / 200
                m.marioObj.header.gfx.scale.y = 1 + min(math.abs(m.vel.y), 100) / 100
                m.marioObj.header.gfx.scale.z = 1 - min(math.abs(m.vel.y), 100) / 200
            end

            if m.action == ACT_KING_BOUNCE_LAND or m.action == ACT_KING_BALL_LAND then
                align_with_floor(m)
                m.marioObj.header.gfx.scale.x = 1.5
                m.marioObj.header.gfx.scale.y = 0.75
                m.marioObj.header.gfx.scale.z = 1.5
            end

            --if (m.flags & MARIO_WING_CAP) ~= 0
            --or (m.flags & MARIO_METAL_CAP) ~= 0
            --or (m.flags & MARIO_VANISH_CAP) ~= 0 then
                --djui_chat_message_create("cap")
            --end

            if m.action == ACT_END_PEACH_CUTSCENE then
                if m.actionArg == 9 then -- END_PEACH_CUTSCENE_STAR_DANCE
                    set_mario_animation(m, MARIO_ANIM_DYING_ON_BACK)
                    set_anim_to_frame(m, min(m.actionTimer, m.marioObj.header.gfx.animInfo.curAnim.loopEnd))
                    m.marioBodyState.eyeState = 8

                    if is_anim_past_frame(m, 40) ~= 0 then
                        play_mario_heavy_landing_sound(m, SOUND_ACTION_TERRAIN_BODY_HIT_GROUND)
                    end
                elseif m.actionArg > 9 then
                    set_mario_animation(m, MARIO_ANIM_DYING_ON_BACK)
                    set_anim_to_frame(m, m.marioObj.header.gfx.animInfo.curAnim.loopEnd)
                    m.marioBodyState.eyeState = 8
                end
            end

            if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_COUGHING
            or m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_WALK_PANTING then
                m.marioBodyState.eyeState = 9
            end

            if m.action ~= ACT_GROUND_POUND
            and m.action ~= ACT_GROUND_POUND_LAND
            and m.action ~= ACT_WATER_PLUNGE then
                k.savevel.x = m.vel.x
                k.savevel.y = m.vel.y
                k.savevel.z = m.vel.z
            end

            if m.action == ACT_KING_BALL_AIR
            or m.action == ACT_KING_BOUNCE
            or m.action == ACT_JUMP
            or m.action == ACT_DOUBLE_JUMP
            or m.action == ACT_TRIPLE_JUMP
            or m.action == ACT_LONG_JUMP
            or m.action == ACT_FREEFALL
            or m.action == ACT_DIVE
            or m.action == ACT_FORWARD_ROLLOUT
            or m.action == ACT_WATER_PLUNGE
            or m.action == ACT_GRAB_POLE_FAST then
                if k.saveTimer > 1 then
                    k.saveForwardVel = m.forwardVel
                end
                k.saveTimer = k.saveTimer + 1
            else
                k.saveTimer = 0
                k.saveForwardVel = m.forwardVel
            end

            if m.action == ACT_JUMP
            or m.action == ACT_DOUBLE_JUMP
            or m.action == ACT_TRIPLE_JUMP
            or m.action == ACT_LONG_JUMP
            or m.action == ACT_FREEFALL
            or m.action == ACT_WALL_KICK_AIR
            or m.action == ACT_DIVE
            or m.action == ACT_FORWARD_ROLLOUT
            or m.action == ACT_TOP_OF_POLE_JUMP
            or m.action == ACT_KING_POLE_JUMP
            or m.action == ACT_KING_BOUNCE then
                update_air_memer(m, 1)
            end

            if m.action == ACT_HOLD_JUMP
            or m.action == ACT_HOLD_FREEFALL
            or m.action == ACT_RIDING_SHELL_JUMP
            or m.action == ACT_RIDING_SHELL_FALL
            or m.action == ACT_STEEP_JUMP
            or m.action == ACT_SLIDE_KICK then
                update_air_with_turn(m)
            end

            if (m.input & INPUT_Z_DOWN) ~= 0 then
                if m.action == ACT_LONG_JUMP_LAND or m.action == ACT_LONG_JUMP_LAND_STOP or m.action == ACT_JUMP_LAND_STOP
                or m.action == ACT_DOUBLE_JUMP_LAND_STOP or m.action == ACT_TRIPLE_JUMP_LAND_STOP or m.action == ACT_FREEFALL_LAND_STOP
                or m.action == ACT_JUMP_LAND or m.action == ACT_DOUBLE_JUMP_LAND or m.action == ACT_TRIPLE_JUMP_LAND or m.action == ACT_FREEFALL_LAND
                or m.action == ACT_KING_WALKING or m.action == ACT_BUTT_SLIDE or m.action == ACT_DIVE_SLIDE or m.action == ACT_STOMACH_SLIDE then
                    if m.forwardVel == 0 then
                        return set_mario_action(m, ACT_CROUCHING, 0)
                    else
                        --m.forwardVel = hypot(m.vel.z, m.vel.x)
                        --m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
                        return set_mario_action(m, ACT_KING_ROLLING, 0)
                    end
                end

                if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP
                or m.action == ACT_SIDE_FLIP or m.action == ACT_FREEFALL or m.action == ACT_STEEP_JUMP or m.action == ACT_VERTICAL_WIND then
                    set_mario_action(m, ACT_KING_BALL_AIR, 0)
                end
            end

            if m.action == ACT_LONG_JUMP or m.action == ACT_WALL_KICK_AIR
            or m.action == ACT_BACKFLIP or m.action == ACT_TOP_OF_POLE_JUMP or m.action == ACT_KING_POLE_JUMP then
                if (m.input & INPUT_Z_PRESSED) ~= 0 then
                    set_mario_action(m, ACT_KING_BALL_AIR, 0)
                elseif (m.input & INPUT_Z_DOWN) ~= 0 then
                    if (m.input & INPUT_B_PRESSED) ~= 0 then
                        set_mario_action(m, ACT_KING_BOUNCE, 0)
                    end
                    if (m.input & INPUT_A_PRESSED) ~= 0
                    and k.jumpTimer > 0 and k.djumped == 0 then
                        set_mario_action(m, ACT_KING_BALL_AIR, 1)
                    end
                else
                    if (m.input & INPUT_B_PRESSED) ~= 0 then
                        set_mario_action(m, ACT_DIVE, 0)
                    end
                end
            end

            if m.action == ACT_SLIDE_KICK_SLIDE then
                if (m.input & INPUT_Z_DOWN) ~= 0
                and mario_floor_is_steep(m) == 0 then
                    if (m.input & INPUT_B_PRESSED) ~= 0 then
                        set_mario_action(m, ACT_KING_ROLLDASH, 0)
                    end
                end
            end

            if m.action == ACT_SHOT_FROM_CANNON then
                k.djumped = 1

                if m.vel.y <= 0 then
                    set_mario_action(m, ACT_KING_BALL_AIR, 0)
                    set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
                end

                if (m.input & INPUT_Z_DOWN) ~= 0 and (m.input & INPUT_B_PRESSED) ~= 0 then
                    set_mario_action(m, ACT_KING_BOUNCE, 0)
                    set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
                end

                set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
                set_anim_to_frame(m, get_global_timer()*2 % m.marioObj.header.gfx.animInfo.curAnim.loopEnd)
            end

            if m.action == ACT_FLYING then
                k.djumped = 1

                if (m.input & INPUT_Z_DOWN) ~= 0 and (m.input & INPUT_B_PRESSED) ~= 0 then
                    m.actionTimer = 0
                    set_mario_action(m, ACT_KING_BOUNCE, 0)
                    set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
                end

                if m.wallKickTimer == 0 then
                    if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FORWARD_SPINNING then
                        set_mario_action(m, ACT_FLYING, 1)
                    end

                    if (m.input & INPUT_A_PRESSED) ~= 0 then
                        mario_set_forward_vel(m, max(m.forwardVel, 96))
                        m.wallKickTimer = 60
                    end
                else
                    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
                    local animFrame = get_global_timer()*4 % m.marioObj.header.gfx.animInfo.curAnim.loopEnd

                    set_anim_to_frame(m, animFrame)

                    if animFrame <= 2 then
                        play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
                    end
                end

                m.wallKickTimer = min(max(m.wallKickTimer - 1, 0), 60)
            end

            if m.pos.y == m.floorHeight
            or (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED
            or (m.action & ACT_FLAG_ON_POLE) ~= 0
            or m.action == ACT_KING_POLE_JUMP then
                k.djumped = 0
            end

            if (m.input & INPUT_Z_DOWN) ~= 0 and (m.input & INPUT_B_PRESSED) ~= 0
            and (m.action == ACT_START_CRAWLING or m.action == ACT_STOP_CRAWLING or m.action == ACT_START_CROUCHING or m.action == ACT_STOP_CROUCHING) then
                set_mario_action(m, ACT_KING_ROLLDASH, 0)
            end

            if (m.flags & MARIO_METAL_CAP) == 0 then
                m.peakHeight = min(m.peakHeight, 1150 + m.vel.y + m.pos.y)

                if (m.input & INPUT_Z_DOWN) ~= 0 and (m.action == ACT_WATER_PLUNGE or m.action == ACT_WATER_IDLE or m.action == ACT_WATER_PUNCH
                or m.action == ACT_WATER_ACTION_END or m.action == ACT_BREASTSTROKE or m.action == ACT_FLUTTER_KICK or m.action == ACT_SWIMMING_END) then
                    set_mario_action(m, ACT_KING_FLOAT, 0)
                end
            else
                if m.action == ACT_KING_BOUNCE or m.action == ACT_KING_BOUNCE_LAND
                or m.action == ACT_KING_BALL_AIR or m.action == ACT_KING_BALL_LAND then
                    m.peakHeight = min(m.peakHeight, 1150 + m.vel.y + m.pos.y)
                end                             -- metal bounces go high enough to kill
            end

            if m.action ~= ACT_KING_FLOAT then
                k.float = 0
            end

            if m.action ~= ACT_KING_ROLLING then
                k.rollYvel = 0
            end

            if m.action ~= ACT_WATER_PLUNGE then
                k.saveYpos = m.pos.y
            end

            if m.action == ACT_AIR_HIT_WALL then
                m.marioObj.header.gfx.angle.y = m.faceAngle.y + 0x8000
                mario_set_forward_vel(m, min(m.forwardVel, 96))
            end

            if m.action == ACT_LONG_JUMP_LAND and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                return set_jumping_action(m, ACT_DOUBLE_JUMP, 0)
            end

            local scale = 0.65
            if (m.action & ACT_FLAG_SHORT_HITBOX) == 0 then
                m.marioObj.hitboxHeight = 160 * scale
            else
                m.marioObj.hitboxHeight = 100 * scale
            end

            m.marioObj.hitboxRadius = 37 * scale

            if (m.action & ACT_FLAG_HANGING) ~= 0 then
                m.marioObj.header.gfx.pos.y = m.ceilHeight - m.marioObj.hitboxHeight
            end
        else
            gSync.modelId = nil
        end
    end
end

function before_mario_update(m)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]

    if m.playerIndex == 0 then
        if gSync.isKing then
            if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_WALL_KICK_AIR
            or m.action == ACT_TOP_OF_POLE_JUMP or m.action == ACT_KING_POLE_JUMP or m.action == ACT_STEEP_JUMP or m.action == ACT_LONG_JUMP
            or m.action == ACT_JUMP_KICK or m.action == ACT_SLIDE_KICK or (m.action == ACT_DIVE and m.actionArg == 1) or m.action == ACT_BACKFLIP then
                if m.action ~= ACT_TRIPLE_JUMP and m.action ~= ACT_BACKFLIP and k.jumpTimer == 1 then
                    do_king_whoosh(m)
                end

                k.jumpTimer = k.jumpTimer + 1
            else
                k.jumpTimer = 0
            end

            if m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING then
                if m.actionArg == 1 then
                    if k.punchSound == 0 then
                        do_king_whoosh(m)
                        k.punchSound = 1
                    end
                elseif m.actionArg == 3 then
                    if k.punchSound == 1 then
                        do_king_whoosh(m)
                        k.punchSound = 0
                    end
                elseif m.actionArg == 6 then
                    if k.punchSound == 0 then
                        do_king_whoosh(m)
                        k.punchSound = 1
                    end
                end
            else
                k.punchSound = 0
            end

            --if m.squishTimer ~= 0 then
                --mario_set_forward_vel(m, min(max(m.forwardVel, -32), 32))

                --if m.action == ACT_KING_WALKING then
                    --m.forwardVel = approach_f32_symmetric(m.forwardVel, 16, m.intendedMag / 4)
                --end
            --end
        end
    end
end

function do_king_whoosh(m)
    local k = gKingStates[m.playerIndex]
    local randSound = math.random(0, 1)
    local randFreq = 0.875 + math.random()/4

    if k.starKing.enabled == 0 then
        if randSound == 0 then
            play_sound_with_freq_scale(SOUND_ACTION_THROW, m.marioObj.header.gfx.cameraToObject, randFreq)
        else
            play_sound_with_freq_scale(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject, randFreq)
        end
    else
        play_sound_with_freq_scale(SOUND_GENERAL_GRAND_STAR_JUMP, m.marioObj.header.gfx.cameraToObject, randFreq)
    end
end

function on_sound(soundBits, pos)
    local m = gMarioStates[0]
    local gSync = gPlayerSyncTable[0]
    local k = gKingStates[0]

    if m.playerIndex == 0 and gSync.isKing then
        -- the position is off by like an incomprehensible amount so i had to round each value
        if math.floor(pos.x) == math.floor(m.marioObj.header.gfx.cameraToObject.x)
        and math.floor(pos.y) == math.floor(m.marioObj.header.gfx.cameraToObject.y)
        and math.floor(pos.z) == math.floor(m.marioObj.header.gfx.cameraToObject.z) then
            if k.starKing.enabled == 1 then
                if soundBits == SOUND_ACTION_THROW or soundBits == SOUND_ACTION_TWIRL
                or soundBits == SOUND_ACTION_SIDE_FLIP_UNK or soundBits == SOUND_ACTION_SPIN then
                    return SOUND_GENERAL_GRAND_STAR_JUMP
                end
            end
        end

        if soundBits == SOUND_MENU_THANK_YOU_PLAYING_MY_GAME then
            audio_sample_stop(SAMPLE_END_CAKE)
            audio_sample_play(SAMPLE_END_CAKE, pos, 1)
            return NO_SOUND
        end
    end
end

function allow_hazard_surface(m)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]

    if m.playerIndex == 0 and gSync.isKing and k.starKing.enabled == 1 then
        return false
    end
end

function mario_on_set_action(m)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]

    if m.playerIndex == 0 and gSync.isKing then
        if m.action == ACT_DIVE then
            m.faceAngle.x = 0
            m.faceAngle.z = 0
        end

        if m.action == ACT_KING_WALKING then
            m.marioObj.oMarioWalkingPitch = 0
        end

        if m.action == ACT_KING_BALL_AIR
        or m.action == ACT_JUMP
        or m.action == ACT_DOUBLE_JUMP
        or m.action == ACT_TRIPLE_JUMP
        or m.action == ACT_LONG_JUMP
        or m.action == ACT_SLIDE_KICK then
            if (m.input & INPUT_OFF_FLOOR) == 0 then
                m.pos.y = m.pos.y + 16

                if m.floor.object then
                    m.vel.y = m.vel.y + m.floor.object.oVelY
                end
            end
        end

        if m.action == ACT_KING_BOUNCE
        or m.action == ACT_JUMP
        or m.action == ACT_DOUBLE_JUMP
        or m.action == ACT_TRIPLE_JUMP
        or m.action == ACT_LONG_JUMP
        or m.action == ACT_FREEFALL
        or m.action == ACT_DIVE
        or m.action == ACT_FORWARD_ROLLOUT
        or m.action == ACT_WATER_PLUNGE then
            m.forwardVel = k.saveForwardVel
        end

        if m.action == ACT_DOUBLE_JUMP then
            m.vel.y = min(m.vel.y, 64)
        end

        if m.action == ACT_JUMP
        or m.action == ACT_DIVE then
            m.vel.y = min(m.vel.y, 56)
        end

        if m.action == ACT_DIVE and m.actionArg == 1 then
            m.forwardVel = min(m.forwardVel, 96)
        end

        if m.action == ACT_GROUND_POUND
        or m.action == ACT_GROUND_POUND_LAND then
            m.vel.x = k.savevel.x
            m.vel.y = k.savevel.y
            m.vel.z = k.savevel.z

            return set_mario_action(m, ACT_KING_BALL_AIR, 0)
        end

        if m.action == ACT_WATER_PLUNGE then
            m.pos.y = k.saveYpos
            m.vel.x = k.savevel.x
            m.vel.y = k.savevel.y / 2.5
            m.vel.z = k.savevel.z
        end

        if m.action == ACT_WATER_JUMP then
            set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
            return set_mario_action(m, ACT_JUMP, 0)
        end

        if m.action == ACT_CROUCH_SLIDE then
            if m.forwardVel == 0 then
                return set_mario_action(m, ACT_CROUCHING, 0)
            else
                return set_mario_action(m, ACT_KING_ROLLING, 0)
            end
        end

        if m.prevAction ~= ACT_KING_ROLLDASH then
            if m.action == ACT_SLIDE_KICK or ((m.action == ACT_MOVE_PUNCHING or m.action == ACT_PUNCHING) and (m.actionArg == 9 or m.prevAction == ACT_CRAWLING)) then
                return set_mario_action(m, ACT_KING_ROLLDASH, 0)
            end
        end

        if (m.input & INPUT_Z_DOWN) ~= 0 and
        (m.action == ACT_DIVE or m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING) then
            if (m.input & INPUT_OFF_FLOOR) ~= 0 then
                return set_mario_action(m, ACT_KING_BOUNCE, 0)
            else
                return set_mario_action(m, ACT_KING_ROLLDASH, 0)
            end
        end

        if m.action == ACT_WALKING then
            return set_mario_action(m, ACT_KING_WALKING, 0)
        end

        if m.action == ACT_SPECIAL_TRIPLE_JUMP or m.action == ACT_KING_SPECIAL_BALL then
            audio_sample_stop(SAMPLE_YOSHI_TJUMP)
            audio_sample_play(SAMPLE_YOSHI_TJUMP, m.pos, 1)
        end

        if m.action == ACT_GRAB_POLE_FAST then
            if k.saveForwardVel >= 64 then
                m.marioObj.oMarioPoleYawVel = k.saveForwardVel * 40
                return set_mario_action(m, ACT_KING_POLE_SPIN, 0)
            end
        end

        if m.action == ACT_KING_BALL_AIR
        and (m.prevAction == ACT_KING_BALL_LAND or m.prevAction == ACT_KING_BOUNCE_LAND) then
            m.actionTimer = 8
        end

        if (m.prevAction & ACT_FLAG_HANGING) ~= 0 and (m.action & ACT_FLAG_HANGING) == 0 then
            m.pos.y = m.ceilHeight - m.marioObj.hitboxHeight
        end

        -- this alone fixes thirdies
        -- yes im calling them thirdies
        if m.action == ACT_AIR_HIT_WALL then
            return set_mario_animation(m, MARIO_ANIM_START_WALLKICK)
        end

        if m.action == ACT_WALL_KICK_AIR then
            if m.prevAction == ACT_AIR_HIT_WALL or (m.particleFlags & PARTICLE_VERTICAL_STAR) ~= 0 then
                m.particleFlags = m.particleFlags & ~PARTICLE_VERTICAL_STAR

                if analog_stick_held_back(m) ~= 0 then
                    mario_set_forward_vel(m, min(m.forwardVel, 24))
                else
                    m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
                end
            end
        end

        k.jumpTimer = 0
    end
end

function on_interact(m, o)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]
    local bhv = get_id_from_behavior(o.behavior)

    if m.playerIndex == 0 and gSync.isKing then
        if bhv == id_bhvNormalCap then
            m.flags = m.flags | MARIO_NORMAL_CAP
        end

        if o.oInteractType == INTERACT_BOUNCE_TOP or o.oInteractType == INTERACT_BOUNCE_TOP2 or o.oInteractType == INTERACT_PLAYER then
            k.djumped = 0

            if m.action == ACT_KING_BALL_AIR then
                o.oInteractStatus = ATTACK_FROM_ABOVE + (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED)
                m.vel.y = 40 + max(m.peakHeight - m.pos.y, 0)/30
            end

            if m.action == ACT_KING_BOUNCE then
                o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL + (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED)
                m.vel.y = 60 + max(m.peakHeight - m.pos.y, 0)/30
                return set_mario_action(m, ACT_KING_BALL_AIR, 0)
            end
        end

        if m.action == ACT_KING_FLOAT or m.action == ACT_KING_WALKING then
            if bhv == id_bhvDoorWarp then
                set_mario_action(m, ACT_DECELERATING, 0)
                interact_warp_door(m, 0, o)
            elseif bhv == id_bhvDoor or bhv == id_bhvStarDoor then
                set_mario_action(m, ACT_DECELERATING, 0)
                interact_door(m, 0, o)
            end
        end
    end
end

function king_attack_object(m, interaction, o)
    --ATTACK_GROUND_POUND_OR_TWIRL
    --ATTACK_PUNCH
    --ATTACK_KICK_OR_TRIP
    --ATTACK_FAST_ATTACK
    --ATTACK_FROM_ABOVE
    --ATTACK_FROM_BELOW

    o.oInteractStatus = interaction + (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED)

    o.oMoveAngleYaw = m.faceAngle.y
    o.oForwardVel = 3392 / o.hitboxRadius

    play_sound(SOUND_ACTION_HIT_2, m.marioObj.header.gfx.cameraToObject)

    return interaction
end

function do_king_collide(m, o, ballVel)
    o.oMoveAngleYaw = mario_obj_angle_to_object(m, o)
    o.oForwardVel = ballVel
    o.oVelY = ballVel
end

function allow_interact(m, o)
    local gSync = gPlayerSyncTable[m.playerIndex]
    local k = gKingStates[m.playerIndex]
    local bhv = get_id_from_behavior(o.behavior)

    if m.playerIndex == 0 and gSync.isKing then
        local ballVel = min(max(math.abs(m.forwardVel), 16), 128) + math.abs(o.oForwardVel/2)

        if k.isBall or k.starKing.enabled == 1 then
            if bhv == id_bhvBowlingBall or bhv == id_bhvFreeBowlingBall or bhv == id_bhvPitBowlingBall then
                spawn_sync_object(id_bhvKingBowlingBall, E_MODEL_BOWLING_BALL, o.oPosX, o.oPosY, o.oPosZ, function(newBall)
                    m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE

                    play_sound(SOUND_OBJ_BULLY_METAL, o.header.gfx.cameraToObject)
                    do_king_collide(m, newBall, ballVel)
                    obj_mark_for_deletion(o)
                end)

                return false
            end

            if bhv == id_bhvKingBowlingBall then
                m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE

                play_sound(SOUND_OBJ_BULLY_METAL, o.header.gfx.cameraToObject)
                do_king_collide(m, o, ballVel)
                o.oHealth = o.oHealth - 1
                return false
            end
        end

        if k.isBall and m.forwardVel > 120 then
            if bhv == id_bhvBobomb then
                king_attack_object(m, ATTACK_KICK_OR_TRIP, o)
                return false
            end

            if bhv == id_bhvBreakableBox then
                obj_attack_collided_from_other_object(m.marioObj)
                return false
            end
        end

        if k.canBreak then
            if o.oInteractType == INTERACT_BOUNCE_TOP or o.oInteractType == INTERACT_BOUNCE_TOP2 or o.oInteractType == INTERACT_KOOPA
            or o.oInteractType == INTERACT_SPINY_WALKING or o.oInteractType == INTERACT_BULLY then
                king_attack_object(m, ATTACK_FAST_ATTACK, o)
                return false
            end

            if bhv == id_bhvChainChomp then
                m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE

                play_sound(SOUND_OBJ_BULLY_METAL, o.header.gfx.cameraToObject)
                do_king_collide(m, o, ballVel)
                return false
            end

            if bhv == id_bhvKingBobomb then
                m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE

                o.oHeldState = HELD_THROWN
                play_sound(SOUND_OBJ_BULLY_METAL, o.header.gfx.cameraToObject)
                do_king_collide(m, o, ballVel)
                return false
            end
        end
    end
end

function apply_king_accel(m)
    local steepness = hypot(m.floor.normal.x, m.floor.normal.z)
    local floorDYaw = m.floorAngle - m.faceAngle.y

    if mario_floor_is_slope(m) ~= 0 then
        local slopeAccel = 1.7
        local slopeClass = mario_get_floor_class(m)

        if slopeClass == SURFACE_CLASS_VERY_SLIPPERY then
            slopeAccel = 5.3
        elseif slopeClass == SURFACE_CLASS_SLIPPERY then
            slopeAccel = 2.7
        end

        if floorDYaw > -0x4000 and floorDYaw < 0x4000 then
            m.forwardVel = m.forwardVel + slopeAccel * steepness
        else
            m.forwardVel = m.forwardVel - slopeAccel * steepness
        end
    end

    m.slideYaw = m.faceAngle.y

    m.slideVelX = m.forwardVel * sins(m.faceAngle.y)
    m.slideVelZ = m.forwardVel * coss(m.faceAngle.y)

    m.vel.x = m.slideVelX
    m.vel.y = 0
    m.vel.z = m.slideVelZ

    mario_update_moving_sand(m)
    mario_update_windy_ground(m)
end

function update_king_walking_speed(m)
    local intendedMag = m.intendedMag * 1.6
    local maxTargetSpeed
    local targetSpeed

    if m.floor ~= nil and m.floor.type == SURFACE_SLOW then
        maxTargetSpeed = 32
    else
        maxTargetSpeed = 48
    end

    if intendedMag < maxTargetSpeed then
        targetSpeed = intendedMag
    else
        targetSpeed = maxTargetSpeed
    end

    if m.quicksandDepth > 10 then
        targetSpeed = targetSpeed * 6.25 / m.quicksandDepth
    end

    if m.forwardVel <= targetSpeed then
        m.forwardVel = m.forwardVel + 1.7
    else
        m.forwardVel = m.forwardVel - 1
    end

    local dropDecrease = 4

    if mario_get_floor_class(m) == SURFACE_CLASS_VERY_SLIPPERY
    and (m.area.terrainType & TERRAIN_MASK) == TERRAIN_SNOW then
        dropDecrease = 1

        local difference = math.abs(convert_s16(m.intendedYaw - m.faceAngle.y))
        m.forwardVel = approach_f32_symmetric(m.forwardVel, 0, difference/0x1000)
    end

    if (m.input & INPUT_NONZERO_ANALOG) == 0 then
        m.forwardVel = approach_f32_symmetric(m.forwardVel, 0, dropDecrease)
        if m.forwardVel == 0 then
            return begin_braking_action(m)
        end
    end

    if m.forwardVel > 250 then
        m.forwardVel = 250
    end

    if m.forwardVel < -96 then
        m.forwardVel = -96
    end

    m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0xA00, 0xA00)
    apply_king_accel(m)
end

function play_king_step_sound(m, frame1, frame2)
    if is_anim_past_frame(m, frame1) ~= 0 or is_anim_past_frame(m, frame2) ~= 0 then

        if (m.flags & MARIO_METAL_CAP) ~= 0 then
            if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TIPTOE then
                play_sound_and_spawn_particles(m, SOUND_ACTION_METAL_STEP_TIPTOE, 0)
            else
                play_sound_and_spawn_particles(m, SOUND_ACTION_METAL_STEP, 0)
            end
        elseif m.quicksandDepth > 50 then
            play_sound(SOUND_ACTION_QUICKSAND_STEP, m.marioObj.header.gfx.cameraToObject)
        elseif m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TIPTOE then
            play_sound_and_spawn_particles(m, SOUND_ACTION_TERRAIN_STEP_TIPTOE, 0)
        else
            play_sound_and_spawn_particles(m, SOUND_ACTION_TERRAIN_STEP, 0)
        end

        m.particleFlags = m.particleFlags | PARTICLE_DUST
    end
end

function update_king_walking_anim(m)
    local targetPitch = -find_floor_slope(m, 0) * min(m.forwardVel, 40)/40
    local speed = max(m.forwardVel, m.intendedMag)
    local animAccel = min(max(speed, 16), 96) / 4 * 0x10000

    if m.quicksandDepth > 50 then
        set_mario_anim_with_accel(m, MARIO_ANIM_MOVE_IN_QUICKSAND, animAccel)
        play_king_step_sound(m, 19, 93)
    else
        if m.actionTimer == 0 then
            if speed >= 10 then
                m.actionTimer = 1
            end

            set_mario_anim_with_accel(m, MARIO_ANIM_TIPTOE, animAccel)
            play_king_step_sound(m, 14, 72)
        elseif m.actionTimer == 1 then
            if speed < 5 then
                m.actionTimer = 0
            elseif speed >= 20 then
                m.actionTimer = 2
            end

            set_mario_anim_with_accel(m, MARIO_ANIM_WALKING, animAccel)
            play_king_step_sound(m, 10, 49)
        elseif m.actionTimer == 2 then
            if speed < 15 then
                m.actionTimer = 1
            elseif speed >= 40 then
                m.actionTimer = 3
            end

            set_mario_anim_with_accel(m, MARIO_ANIM_RUNNING, animAccel)
            smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_JOG")
            play_king_step_sound(m, 11, 51)
        elseif m.actionTimer == 3 then
            if speed < 35 then
                m.actionTimer = 2
            end

            set_mario_anim_with_accel(m, MARIO_ANIM_RUNNING, animAccel)

            if speed < 120 then
                smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_RUN")
                play_king_step_sound(m, 11, 51)
            else
                smlua_anim_util_set_animation(m.marioObj, "KING_ANIM_FIRE")
                play_king_step_sound(m, 9, 45)
                targetPitch = targetPitch - 0x1000
                m.marioBodyState.eyeState = 8
            end
        end
    end

    if mario_get_floor_class(m) == SURFACE_CLASS_VERY_SLIPPERY
    and (m.area.terrainType & TERRAIN_MASK) == TERRAIN_SNOW then
        m.marioObj.header.gfx.angle.y = m.intendedYaw
    end

    m.marioObj.oMarioWalkingPitch = convert_s16(approach_s32(m.marioObj.oMarioWalkingPitch, targetPitch, 0x800, 0x800))
    m.marioObj.header.gfx.angle.x = m.marioObj.oMarioWalkingPitch
end

function act_king_walking(m)
    local startPos = m.pos
    local startYaw = m.faceAngle.y

    mario_drop_held_object(m)

    if m.forwardVel < 128 then
        if should_begin_sliding(m) ~= 0 then
            return set_mario_action(m, ACT_BEGIN_SLIDING, 0)
        end

        if mario_get_floor_class(m) == SURFACE_CLASS_VERY_SLIPPERY
        and (m.area.terrainType & TERRAIN_MASK) == TERRAIN_SNOW then
            -- do nothing
        else
            if (m.input & INPUT_NONZERO_ANALOG) == 0 then
                return begin_braking_action(m)
            end

            if analog_stick_held_back(m) ~= 0 and m.forwardVel >= 16 then
                return set_mario_action(m, ACT_TURNING_AROUND, 0)
            end
        end
    else
        if analog_stick_held_back(m) ~= 0 then
            m.vel.y = m.forwardVel / 4
            play_sound(SOUND_ACTION_SIDE_FLIP_UNK, m.marioObj.header.gfx.cameraToObject)
            return set_mario_action(m, ACT_THROWN_FORWARD, 0)
        end
    end

    if check_ground_dive_or_punch(m) ~= 0 then
        m.vel.y = max(20, m.forwardVel / 4)
        return
    end

    if (m.input & INPUT_FIRST_PERSON) ~= 0 then
        return begin_braking_action(m)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jump_from_landing(m)
    end

    if (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
    end

    m.actionState = 0
    update_king_walking_speed(m)

    local stepResult = perform_ground_step(m)

    if stepResult == GROUND_STEP_LEFT_GROUND then
        if m.forwardVel < 128 then
            set_mario_action(m, ACT_FREEFALL, 0)
            set_mario_animation(m, MARIO_ANIM_GENERAL_FALL)
        else
            m.vel.y = m.forwardVel / 4
            play_sound(SOUND_ACTION_SIDE_FLIP_UNK, m.marioObj.header.gfx.cameraToObject)
            return set_mario_action(m, ACT_THROWN_FORWARD, 0)
        end
    elseif stepResult == GROUND_STEP_NONE then
        update_king_walking_anim(m)
        tilt_body_walking(m, startYaw)
        m.marioObj.header.gfx.angle.z = m.marioBodyState.torsoAngle.z
    elseif stepResult == GROUND_STEP_HIT_WALL then
        if m.forwardVel < 128 then
            push_or_sidle_wall(m, startPos)
        else
            m.vel.y = m.forwardVel / 4
            mario_bonk_reflection(m, 1)
            return set_mario_action(m, ACT_BACKWARD_AIR_KB, 0)
        end
    end

    check_ledge_climb_down(m)
end

function update_air_memer(m, turnValue)
    local sidewaysSpeed = 0
    local intendedDYaw = m.intendedYaw - m.faceAngle.y
    local intendedMag = m.intendedMag / 32
    local hardCap = 250
    local softCap = 96

    m.forwardVel = approach_f32_symmetric(m.forwardVel, 0, 0.35)

    if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
        if m.forwardVel <= softCap/2 then
            m.forwardVel = m.forwardVel + intendedMag * coss(intendedDYaw)
        else
            m.forwardVel = m.forwardVel + intendedMag * coss(intendedDYaw) / 2
        end

        if turnValue == 0 then
            sidewaysSpeed = intendedMag * sins(intendedDYaw) * 10
        elseif turnValue == 1 then
            m.faceAngle.y = m.faceAngle.y + 512 * sins(intendedDYaw) * intendedMag
        elseif turnValue == 2 then
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x1000, 0x1000)
            if m.faceAngle.y ~= m.intendedYaw and m.forwardVel > 32 then
                mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, m.forwardVel/16))
            end
        end
    end

    -- cap speed when way too fast
    if m.forwardVel > hardCap then
        m.forwardVel = hardCap
    end

    -- lower backwards cap, more control
    if m.forwardVel < -softCap then
        m.forwardVel = -softCap
    end

    -- decelerate when at top speed
    if m.forwardVel > softCap then
        m.forwardVel = m.forwardVel - 1
    end

    m.slideVelX = m.forwardVel * sins(m.faceAngle.y)
    m.slideVelZ = m.forwardVel * coss(m.faceAngle.y)

    if turnValue == 0 then
        m.slideVelX = m.slideVelX + sidewaysSpeed * sins(m.faceAngle.y + 0x4000)
        m.slideVelZ = m.slideVelZ + sidewaysSpeed * coss(m.faceAngle.y + 0x4000)
    end

    m.vel.x = m.slideVelX
    m.vel.z = m.slideVelZ
end

function king_physics(m, height, yvel, speed)
    local slopeAngle = atan2s(m.floor.normal.z, m.floor.normal.x)
    local angleDist = (0.5 - math.abs(convert_s16(m.faceAngle.y - slopeAngle)) / 0x8000) * 2
    local steepness = hypot(m.floor.normal.x, m.floor.normal.z) * 0x2000

    if height ~= 0 then
        yvel = height
    else
        yvel = -yvel
    end

    height = yvel * coss(steepness)
    speed = speed + yvel * sins(steepness) * angleDist

    return {
        ["height"] = height,
        ["speed"] = speed
    }
end

function set_king_jump_action(m, jumpHeight, doPhysics, jumpAct)
    if m.playerIndex == 0 then
        if m.quicksandDepth >= 11 then
            -- Checks whether Mario is holding an object or not.
            if m.heldObj == nil then
                return set_mario_action(m, ACT_QUICKSAND_JUMP_LAND, 0)
            else
                return set_mario_action(m, ACT_HOLD_QUICKSAND_JUMP_LAND, 0)
            end
        else
            set_mario_action(m, jumpAct, 0)
        end

        if doPhysics == 1 then
            local physics = king_physics(m, jumpHeight, m.vel.y, m.forwardVel)

            mario_set_forward_vel(m, physics.speed)
            gKingStates[m.playerIndex].saveForwardVel = physics.speed
            m.vel.y = physics.height
        else
            m.vel.y = jumpHeight
        end
    end
end

function act_king_ball_air(m)
    local k = gKingStates[m.playerIndex]
    common_air_action_step(m, ACT_KING_BALL_LAND, MARIO_ANIM_FORWARD_SPINNING, AIR_STEP_CHECK_LEDGE_GRAB | AIR_STEP_CHECK_HANG)

    if m.actionState == 0 then
        if (k.djumped == 0 and (m.input & INPUT_A_PRESSED) ~= 0) or m.actionArg == 1 then

            if (m.flags & MARIO_WING_CAP) == 0 then
                do_king_whoosh(m)
                m.vel.y = max(m.vel.y, 40)
            else
                m.vel.y = max(m.vel.y, 80)
                m.actionState = 1
            end

            k.djumped = 1
            m.actionArg = 0
            m.actionTimer = 8
        end

        if (m.input & INPUT_B_PRESSED) ~= 0 then
            set_mario_action(m, ACT_KING_BOUNCE, 0)
        end

        if (m.input & INPUT_Z_DOWN) == 0 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end

        local animAccel = math.abs(hypot(m.forwardVel, m.vel.y))
        set_mario_anim_with_accel(m, MARIO_ANIM_FORWARD_SPINNING, max(animAccel, 16)/32 * 0x10000)
    else
        if m.marioObj.header.gfx.animInfo.animFrame == 1 then
            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
        end

        if m.vel.y < 4 then
            mario_set_forward_vel(m, max(m.forwardVel, 32))
            set_mario_action(m, ACT_FLYING, 1)
        end
    end

    m.actionTimer = max(m.actionTimer - 1, 0)
end

function act_king_ball_land(m)
    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    if m.actionTimer >= 1 or (m.input & INPUT_OFF_FLOOR) ~= 0 then
        local jumpHeight = min(math.abs(m.vel.y), 80) - 15

        if jumpHeight >= 32 then
            play_sound(SOUND_KING_BOING, m.marioObj.header.gfx.cameraToObject)
        elseif jumpHeight >= 16 then
            play_sound(SOUND_GENERAL_SHORT_POUND1, m.marioObj.header.gfx.cameraToObject)
        else
            play_mario_heavy_landing_sound(m, SOUND_ACTION_TERRAIN_BODY_HIT_GROUND)
        end

        if jumpHeight > 10 then
            if m.specialTripleJump == 0 then
                set_king_jump_action(m, jumpHeight, 1, ACT_KING_BALL_AIR)
            else
                set_king_jump_action(m, jumpHeight, 1, ACT_KING_SPECIAL_BALL)
            end

            if (m.flags & MARIO_METAL_CAP) ~= 0 then
                play_mario_sound(m, SOUND_ACTION_METAL_STEP, 0)
            end
        else
            if m.forwardVel == 0 then
                return set_mario_action(m, ACT_CROUCHING, 0)
            else
                return set_mario_action(m, ACT_KING_ROLLING, 0)
            end
        end
    end

    m.actionTimer = m.actionTimer + 1
end

function act_king_bounce(m)
    local stepResult = common_air_action_step(m, ACT_KING_BOUNCE_LAND, MARIO_ANIM_FORWARD_SPINNING, AIR_STEP_CHECK_LEDGE_GRAB | AIR_STEP_CHECK_HANG)

    if stepResult == AIR_STEP_LANDED then
        m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_HORIZONTAL_STAR
    else
        if (m.flags & MARIO_METAL_CAP) ~= 0 then
            if (20 * m.actionTimer) > -300 then
                m.vel.y = m.vel.y - (20 * m.actionTimer)
            end

            if m.actionTimer == 0 then
                play_mario_sound(m, SOUND_ACTION_METAL_BONK, 0)
            end
        else
            if m.vel.y > -150 then
                m.vel.y = -150
            end
        end

        if m.actionTimer == 0 then
            play_sound(SOUND_KING_BOUNCE, m.marioObj.header.gfx.cameraToObject)
        end
    end

    m.actionTimer = m.actionTimer + 1
end

function act_king_bounce_land(m)
    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    if (m.flags & MARIO_METAL_CAP) ~= 0 then
        if m.actionTimer > 3 or (m.input & INPUT_OFF_FLOOR) ~= 0 then
            set_camera_shake_from_hit(SHAKE_GROUND_POUND)
            play_mario_sound(m, SOUND_ACTION_METAL_BONK, 0)
            play_sound(SOUND_KING_BOUNCE, m.marioObj.header.gfx.cameraToObject)

            if m.specialTripleJump == 0 then
                set_king_jump_action(m, 80, 1, ACT_KING_BALL_AIR)
            else
                set_king_jump_action(m, 80, 1, ACT_KING_SPECIAL_BALL)
            end
        end
    else
        if m.actionTimer > 1 or (m.input & INPUT_OFF_FLOOR) ~= 0 then
            if m.specialTripleJump == 0 then
                set_king_jump_action(m, 64, 1, ACT_KING_BALL_AIR)
            else
                set_king_jump_action(m, 64, 1, ACT_KING_SPECIAL_BALL)
            end
            play_sound(SOUND_KING_BOUNCE, m.marioObj.header.gfx.cameraToObject)
        end
    end

    m.actionTimer = m.actionTimer + 1
end

function update_king_rolling_angle(m, accel, lossFactor)
    local newFacingDYaw
    local facingDYaw

    local floor = m.floor
    local slopeAngle = atan2s(floor.normal.z, floor.normal.x)
    local steepness = hypot(floor.normal.x, floor.normal.z)

    m.slideVelX = m.slideVelX + accel * steepness * sins(slopeAngle)
    m.slideVelZ = m.slideVelZ + accel * steepness * coss(slopeAngle)

    m.slideVelX = m.slideVelX * lossFactor
    m.slideVelZ = m.slideVelZ * lossFactor

    m.slideYaw = atan2s(m.slideVelZ, m.slideVelX)

    facingDYaw = convert_s16(m.faceAngle.y - m.slideYaw)
    newFacingDYaw = convert_s32(facingDYaw)

    --! -0x4000 not handled - can slide down a slope while facing perpendicular to it
    if newFacingDYaw > 0 and newFacingDYaw <= 0x4000 then
        newFacingDYaw = newFacingDYaw - 0x200
        if newFacingDYaw < 0 then
            newFacingDYaw = 0
        end
    elseif newFacingDYaw > -0x4000 and newFacingDYaw < 0 then
        newFacingDYaw = newFacingDYaw + 0x200
        if newFacingDYaw > 0 then
            newFacingDYaw = 0
        end
    elseif newFacingDYaw > 0x4000 and newFacingDYaw < 0x8000 then
        newFacingDYaw = newFacingDYaw + 0x200
        if newFacingDYaw > 0x8000 then
            newFacingDYaw = 0x8000
        end
    elseif newFacingDYaw > -0x8000 and newFacingDYaw < -0x4000 then
        newFacingDYaw = newFacingDYaw - 0x200
        if newFacingDYaw < -0x8000 then
            newFacingDYaw = -0x8000
        end
    end

    m.faceAngle.y = (m.slideYaw - newFacingDYaw - approach_s32(convert_s16(m.slideYaw - newFacingDYaw - m.faceAngle.y), 0, 0x1000, 0x1000))

    m.vel.x = m.slideVelX
    m.vel.y = 0
    m.vel.z = m.slideVelZ

    mario_update_moving_sand(m)
    mario_update_windy_ground(m)

    m.forwardVel = hypot(m.slideVelX, m.slideVelZ)

    if newFacingDYaw < -0x4000 or newFacingDYaw > 0x4000 then
        m.forwardVel = m.forwardVel * -1
    end
end

function update_king_rolling(m, stopSpeed, stepResult)
    local lossFactor
    local accel
    local oldSpeed
    local newSpeed

    local stopped = false

    local intendedDYaw = m.intendedYaw - m.slideYaw
    local forward = coss(intendedDYaw)
    local sideward = sins(intendedDYaw)

    --! 10k glitch
    if forward < 0 and m.forwardVel >= 0 then
        forward = forward * 0.5 + 0.5 * m.forwardVel / 100
    end

    accel = 10
    lossFactor = m.intendedMag / 32 * forward * 0.02 + 0.98

    oldSpeed = hypot(m.slideVelX, m.slideVelZ)

    -- This is attempting to use trig derivatives to rotate Mario's speed.
    -- It is slightly off/asymmetric since it uses the new X speed, but the old
    -- Z speed.
    m.slideVelZ = m.slideVelZ + m.slideVelZ * (m.intendedMag / 32) * sideward * 0.05
    m.slideVelX = m.slideVelX - m.slideVelX * (m.intendedMag / 32) * sideward * 0.05

    newSpeed = hypot(m.slideVelX, m.slideVelZ)

    if oldSpeed > 0 and newSpeed > 0 then
        m.slideVelX = m.slideVelX * oldSpeed / newSpeed
        m.slideVelZ = m.slideVelZ * oldSpeed / newSpeed
    end

    update_king_rolling_angle(m, accel, lossFactor)

    if stepResult == GROUND_STEP_LEFT_GROUND then
        m.vel.y = gKingStates[m.playerIndex].rollYvel
        set_mario_action(m, ACT_KING_BALL_AIR, 0)
    end

    if stopSpeed ~= 0 then
        if (m.input & INPUT_ABOVE_SLIDE) == 0 and m.forwardVel * m.forwardVel < stopSpeed * stopSpeed then
            set_mario_action(m, ACT_CROUCHING, 0)
            mario_set_forward_vel(m, 0)
            stopped = true
        end
    else
        stopped = false
    end

    return stopped
end

function act_king_rolling(m)
    local k = gKingStates[m.playerIndex]
    local oldypos = m.pos.y

    local stepResult = perform_ground_step(m)

    if stepResult == GROUND_STEP_NONE then
        local stopTurn = min(math.abs(convert_s16(m.intendedYaw - m.faceAngle.y)) / 0x500, 0x2000)

        if analog_stick_held_back(m) ~= 0 then
            stopTurn = math.abs(m.forwardVel / 32)
        else
            local rollTurn = max(max(0x2000 - math.abs(m.forwardVel * 50), 0x500) - stopTurn, 0)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, rollTurn, rollTurn)
        end

        if m.faceAngle.y ~= m.intendedYaw and math.abs(m.forwardVel) > 32 then
            mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, stopTurn))
        else
            mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, 0.5))
        end

        if m.forwardVel ~= 0 then
            m.faceAngle.y = atan2s(m.slideVelZ, m.slideVelX)
        end

        align_with_floor(m)
    elseif stepResult == GROUND_STEP_HIT_WALL then
        mario_bonk_reflection(m, 1)
        m.faceAngle.y = m.faceAngle.y + 0x8000
    end

    update_king_rolling(m, 5, stepResult)

    if (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_KING_ROLLDASH, 0)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        if m.forwardVel ~= 0 then
            m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
        end
        set_king_jump_action(m, min(30 + k.rollYvel, 100), 0, ACT_LONG_JUMP)
        m.forwardVel = m.forwardVel - k.rollYvel
    end

    if (m.input & INPUT_Z_DOWN) == 0 then
        set_mario_action(m, ACT_KING_WALKING, 0)
    end

    set_mario_anim_with_accel(m, MARIO_ANIM_FORWARD_SPINNING, m.forwardVel/32 * 0x10000)

    if m.forwardVel > 250 then
        m.forwardVel = 250
    end

    if m.forwardVel < -96 then
        m.forwardVel = -96
    end

    if m.floor.normal.y <= 0.99 then
        k.rollYvel = (m.pos.y - oldypos) * min(m.forwardVel, 200) / 250
    else
        k.rollYvel = 0
    end

    m.actionTimer = m.actionTimer + 1
end

function act_king_rolldash(m)
    local k = gKingStates[m.playerIndex]

    if (m.input & INPUT_OFF_FLOOR) == 0 then
        perform_ground_step(m)
    else
        perform_air_step(m, 0)
    end

    if m.actionTimer <= 1 then
        play_sound(SOUND_KING_CHARGE, m.marioObj.header.gfx.cameraToObject)
    end

    if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
        k.rDashAngle = m.intendedYaw
    end

    m.faceAngle.y = k.rDashAngle - approach_s32(convert_s16(k.rDashAngle - m.faceAngle.y), 0, 0x200, 0x200)

    m.marioObj.header.gfx.angle.y = k.rDashAngle
    mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, 4))

    k.rdCharge = approach_f32_symmetric(k.rdCharge, 200, 8)

    if k.rdCharge == 200 and m.playerIndex == 0 then
        spawn_non_sync_object(id_bhvSmoke, E_MODEL_SMOKE, m.pos.x, m.pos.y, m.pos.z, function(o)
            o.oMoveAngleYaw = m.marioObj.header.gfx.angle.y + math.random(-0x1000, 0x1000)
            o.oPosY = o.oPosY - math.random(20, 40)
            obj_scale(o, math.random(3, 4)/2)
            o.oVelY = math.random(0, 2)
            o.oForwardVel = -16
        end)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        m.faceAngle.y = k.rDashAngle

        if (m.input & INPUT_OFF_FLOOR) == 0 then
            return set_jumping_action(m, ACT_JUMP, 0)
        else
            return set_mario_action(m, ACT_KING_BALL_AIR, 1)
        end
    end

    if (m.input & INPUT_Z_DOWN) == 0 then
        m.faceAngle.y = k.rDashAngle
        return set_mario_action(m, ACT_IDLE, 0)
    end

    set_mario_anim_with_accel(m, MARIO_ANIM_FORWARD_SPINNING, k.rdCharge/32 * 0x10000)

    if (m.controller.buttonDown & B_BUTTON) == 0 then
        m.faceAngle.y = k.rDashAngle

        if k.rdCharge > 32 then
            m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE

            if m.forwardVel < k.rdCharge then
                mario_set_forward_vel(m, max(math.abs(m.forwardVel) * 2, k.rdCharge) * 3/4)
            end

            play_sound(SOUND_KING_DASH, m.marioObj.header.gfx.cameraToObject)
            set_mario_action(m, ACT_KING_ROLLING, 0)
        else
            m.forwardVel = min(max(m.forwardVel, 16), 96)
            set_mario_animation(m, MARIO_ANIM_SLIDE_KICK)
            set_mario_action(m, ACT_SLIDE_KICK, 0)
        end
    end

    if m.forwardVel > 250 then
        m.forwardVel = 250
    end

    if m.forwardVel < -96 then
        m.forwardVel = -96
    end

    m.actionTimer = m.actionTimer + 1
end

function act_king_float(m)
    local k = gKingStates[m.playerIndex]

    if (m.input & INPUT_Z_DOWN) == 0 then
        return set_mario_action(m, ACT_WATER_IDLE, 0)
    end

    if (m.flags & MARIO_METAL_CAP) ~= 0 then
        return set_mario_action(m, ACT_METAL_WATER_FALLING, 0)
    end

    if m.pos.y <= m.floorHeight and m.vel.y <= 0 then
        step = perform_ground_step(m)
        m.vel.y = 0
    else
        step = perform_water_step(m)
    end

    apply_water_current(m, m.vel)
    set_swimming_at_surface_particles(m, PARTICLE_IDLE_WATER_WAVE)

    if m.playerIndex == 0 then
        set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
    end

    local rollTurn = max(0x2000 - math.abs(m.forwardVel * 50), 0x500)
    local stopTurn = min(math.abs(convert_s16(m.intendedYaw - m.faceAngle.y)) / 0x500, 0x2000)

    m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, rollTurn, rollTurn)
    if m.faceAngle.y ~= m.intendedYaw and m.forwardVel > 32 then
        mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, stopTurn))
    end

    if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
        mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 48, 2))
    else
        mario_set_forward_vel(m, approach_f32_symmetric(m.forwardVel, 0, 1))
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        play_sound(SOUND_KING_SWIM, m.marioObj.header.gfx.cameraToObject)
        m.vel.y = 56
    end
    if (m.input & INPUT_B_PRESSED) ~= 0 then
        play_sound(SOUND_KING_SWIM, m.marioObj.header.gfx.cameraToObject)
        m.vel.y = -56
    end

    if m.pos.y >= m.waterLevel - 140 then
        if (m.area.terrainType & TERRAIN_MASK) ~= TERRAIN_SNOW then
            m.healCounter = 31
        end

        if m.pos.y + m.vel.y * 4 > m.waterLevel then
            m.pos.y = m.waterLevel + 1
            m.vel.y = max(m.vel.y - 10, 0)
            set_mario_action(m, ACT_KING_BALL_AIR, 0)
            k.djumped = 0
        end
    else
        set_mario_particle_flags(m, PARTICLE_BUBBLE, 0)
        if (m.area.terrainType & TERRAIN_MASK) == TERRAIN_SNOW then
            m.health = m.health - 3
        else
            m.health = m.health - 1
        end
    end

    local animAccel = math.abs(hypot(m.forwardVel, m.vel.y))
    set_mario_anim_with_accel(m, MARIO_ANIM_FORWARD_SPINNING, max(animAccel, 16)/32 * 0x10000)

    m.faceAngle.x = 0
    m.faceAngle.z = 0
    m.marioObj.header.gfx.pos.y = m.pos.y + 64
    m.vel.y = max(min(approach_f32(m.vel.y, 48, 4, 4), 56), -56)
    m.actionTimer = m.actionTimer + 1
end

function act_king_special_ball(m)
    if (m.input & INPUT_B_PRESSED) ~= 0 then
        if (m.input & INPUT_Z_DOWN) == 0 then
            return set_mario_action(m, ACT_DIVE, 0)
        else
            return set_mario_action(m, ACT_KING_BOUNCE, 0)
        end
    end

    if (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_GROUND_POUND, 0)
    end

    if m.actionState == 0 then
        if (m.input & INPUT_Z_DOWN) == 0 and m.vel.y > 20 then
            m.vel.y = m.vel.y / 4
        end
    end

    play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, SOUND_MARIO_YAHOO)

    update_air_without_turn(m)

    local stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        local yvel =  min(-m.vel.y, 64) * 0.75

        if (m.input & INPUT_Z_DOWN) ~= 0 and yvel > 20 then
            m.vel.y = yvel
            play_mario_landing_sound(m, SOUND_ACTION_TERRAIN_LANDING)
        else
            set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
        end
    elseif stepResult == AIR_STEP_HIT_WALL then
        mario_bonk_reflection(m, 1)
    end

    if (m.input & INPUT_Z_DOWN) ~= 0 or m.vel.y > 0 then
        if set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING) == 0 then
            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
        end
    else
        set_mario_animation(m, MARIO_ANIM_GENERAL_FALL)
    end

    m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
end

function act_king_pole_spin(m)
    local oldAngle = m.faceAngle.y
    m.faceAngle.y = m.faceAngle.y + m.marioObj.oMarioPoleYawVel * 2
    m.marioObj.oMarioPoleYawVel = m.marioObj.oMarioPoleYawVel - 0x20

    if m.faceAngle.y < oldAngle then
        play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
    end

    if set_pole_position(m, 0) == 0 then
        m.marioObj.oMarioPolePos = m.marioObj.oMarioPolePos + m.marioObj.oMarioPoleYawVel / 0x80

        add_tree_leaf_particles(m)
        play_climbing_sounds(m, 2)

        if (m.input & INPUT_A_PRESSED) ~= 0
        or m.marioObj.oMarioPolePos >= m.usedObj.hitboxHeight - 100 then

            if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
                m.faceAngle.y = m.intendedYaw
            else
                m.faceAngle.y = m.area.camera.yaw - 0x8000
            end

            m.forwardVel = m.marioObj.oMarioPoleYawVel / 0x40

            if m.marioObj.oMarioPolePos >= m.usedObj.hitboxHeight - 100 then
                set_mario_action(m, ACT_KING_POLE_JUMP, 0)
                set_mario_y_vel_based_on_fspeed(m, 62, 0)
                m.forwardVel = max(m.forwardVel * 3/4, 24)
            else
                set_mario_action(m, ACT_WALL_KICK_AIR, 0)
            end
        end

        local bhv = get_id_from_behavior(m.usedObj.behavior)

        if m.marioObj.oMarioPoleYawVel > 0x800
        and bhv ~= id_bhvDDDPole and bhv ~= id_bhvDddMovingPole then
            set_mario_animation(m, MARIO_ANIM_GRAB_POLE_SWING_PART1)
        else
            set_mario_animation(m, MARIO_ANIM_GRAB_POLE_SWING_PART2)
            if is_anim_at_end(m) ~= 0 then
                m.marioObj.oMarioPoleYawVel = 0
                set_mario_action(m, ACT_HOLDING_POLE, 0)
            end
        end
    end
end

function act_king_pole_jump(m)
    play_mario_jump_sound(m)
    common_air_action_step(m, ACT_FREEFALL_LAND, MARIO_ANIM_HANDSTAND_JUMP, AIR_STEP_CHECK_LEDGE_GRAB)
end

---------------------
-- MODELS + SOUNDS --
---------------------

function object_set_model(o, id)
    if charSelectExists then
        return
    end

    if obj_has_behavior_id(o, id_bhvMario) ~= 0 then
        local i = network_local_index_from_global(o.globalPlayerIndex)
        local gSync = gPlayerSyncTable[i]

        if gSync.modelId ~= nil and obj_has_model_extended(o, gSync.modelId) == 0 then
            obj_set_model_extended(o, gSync.modelId)
        end
    end
end

function character_sound(m, charSound)
    local k = gKingStates[m.playerIndex]
    local gSync = gPlayerSyncTable[m.playerIndex]

    if gSync.isKing then
        if charSound == CHAR_SOUND_OKEY_DOKEY and k.kSkin.sfx then
            local sfx = k.kSkin.sfx

            if type(sfx) == "number" then
                return sfx
            else
                audio_sample_play(sfx, m.pos, 1)
            end
        end

        return 0
    end
end

-----------
-- HOOKS --
-----------

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_PLAY_SOUND, on_sound)
hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)
hook_event(HOOK_ALLOW_HAZARD_SURFACE, allow_hazard_surface)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)
hook_event(HOOK_ON_INTERACT, on_interact)
hook_event(HOOK_ALLOW_INTERACT, allow_interact)
hook_event(HOOK_OBJECT_SET_MODEL, object_set_model)
hook_event(HOOK_CHARACTER_SOUND, character_sound)

hook_mario_action(ACT_KING_WALKING, act_king_walking)
hook_mario_action(ACT_KING_BALL_AIR, act_king_ball_air)
hook_mario_action(ACT_KING_BALL_LAND, act_king_ball_land)
hook_mario_action(ACT_KING_BOUNCE, act_king_bounce, INT_HIT_FROM_ABOVE)
hook_mario_action(ACT_KING_BOUNCE_LAND, act_king_bounce_land, INT_GROUND_POUND)
hook_mario_action(ACT_KING_ROLLING, act_king_rolling)
hook_mario_action(ACT_KING_ROLLDASH, act_king_rolldash, INT_FAST_ATTACK_OR_SHELL)
hook_mario_action(ACT_KING_FLOAT, act_king_float, INT_HIT_FROM_BELOW)
hook_mario_action(ACT_KING_SPECIAL_BALL, act_king_special_ball)
hook_mario_action(ACT_KING_POLE_SPIN, act_king_pole_spin)
hook_mario_action(ACT_KING_POLE_JUMP, act_king_pole_jump)

if ktools_act_name then
    ktools_act_name(ACT_KING_WALKING, "ACT_KING_WALKING")
    ktools_act_name(ACT_KING_BALL_AIR, "ACT_KING_BALL_AIR")
    ktools_act_name(ACT_KING_BALL_LAND, "ACT_KING_BALL_LAND")
    ktools_act_name(ACT_KING_BOUNCE, "ACT_KING_BOUNCE")
    ktools_act_name(ACT_KING_BOUNCE_LAND, "ACT_KING_BOUNCE_LAND")
    ktools_act_name(ACT_KING_ROLLING, "ACT_KING_ROLLING")
    ktools_act_name(ACT_KING_ROLLDASH, "ACT_KING_ROLLDASH")
    ktools_act_name(ACT_KING_FLOAT, "ACT_KING_FLOAT")
    ktools_act_name(ACT_KING_SPECIAL_BALL, "ACT_KING_SPECIAL_BALL")
    ktools_act_name(ACT_KING_POLE_SPIN, "ACT_KING_POLE_SPIN")
    ktools_act_name(ACT_KING_POLE_JUMP, "ACT_KING_POLE_JUMP")
end