if gKingStates == nil then return end

TEX_CAKE = get_texture_info("king.end_cake")
TEX_ZL_INPUT = get_texture_info("king.zl_input")
TEX_TRANSITION = get_texture_info("king.transition")
TEX_COURSE_UPPER = get_texture_info("king.course_upper")
TEX_COURSE_LOWER = get_texture_info("king.course_lower")
TEX_POWER_L = get_texture_info("king.power_l")
TEX_POWER_R = get_texture_info("king.power_r")

--[[
function djui_hud_render_texture_shadowed(texInfo, x, y, scaleW, scaleH)
    local color = djui_hud_get_color()

    djui_hud_set_color(0, 0, 0, color.a)
    djui_hud_render_texture(texInfo, x + 1, y + 1, scaleW, scaleH)

    djui_hud_set_color(color.r, color.b, color.g, color.a)
    djui_hud_render_texture(texInfo, x - 1, y - 1, scaleW, scaleH)
end

function djui_hud_print_text_shadowed(message, x, y, scale)
    local color = djui_hud_get_color()

    djui_hud_set_color(0, 0, 0, color.a)
    djui_hud_print_text(message, x + 1, y + 1, scale)

    djui_hud_set_color(color.r, color.b, color.g, color.a)
    djui_hud_print_text(message, x - 1, y - 1, scale)
end
--]]

function render_king_lives()
    local gSync = gPlayerSyncTable[0]
    local k = gKingStates[0]

    local x = 22
    local y = 15

    if gMarioStates[0].action == ACT_INTRO_CUTSCENE
    or (gMarioStates[0].marioObj.activeFlags & ACTIVE_FLAG_ACTIVE) == 0
    or gNetworkPlayers[0].currActNum == 99
    or hud_is_hidden() then
        return
    end

    if gSync.isKing then
        if charSelectExists == nil then
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAG_LIVES)
        else
            charSelect.hud_hide_element(HUD_DISPLAY_FLAG_LIVES)
        end

        djui_hud_render_texture(k.kSkin.icon, x, y, 1, 1)
        djui_hud_print_text(string.upper(k.kSkin.name), x + 16, y, 0.6)
        djui_hud_print_text("@", x + 16, y + 10, 0.4)
        djui_hud_print_text(tostring(hud_get_value(HUD_DISPLAY_LIVES)):gsub("-", "M"), x + 22, y + 10, 0.4)
    else
        if charSelectExists == nil then
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_LIVES)
        else
            charSelect.hud_show_element(HUD_DISPLAY_FLAG_LIVES)
        end
    end

    if k.starKing.timer ~= 0 then
        y = 32

        if not gSync.isKing then
            djui_hud_set_color(0, 0, 255, 127)
            djui_hud_render_texture(gTextures.star, x, y, 0.5, 0.5)
            djui_hud_set_color(85, 85, 85, 127)
        else
            djui_hud_render_texture(gTextures.star, x, y, 0.5, 0.5)
        end

        djui_hud_print_text("@", x + 8, y, 0.5)
        djui_hud_print_text(tostring(math.ceil(k.starKing.timer/30)), x + 16, y, 0.5)
    end
end

function render_king_camera()
    local gSync = gPlayerSyncTable[0]
    local k = gKingStates[0]

    local x = djui_hud_get_screen_width() - 53
    local y = 205

    if gMarioStates[0].action == ACT_INTRO_CUTSCENE
    or (gMarioStates[0].marioObj.activeFlags & ACTIVE_FLAG_ACTIVE) == 0
    or gNetworkPlayers[0].currActNum == 99
    or hud_is_hidden() then
        return
    end

    if gSync.isKing then
        if charSelectExists == nil then
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAG_CAMERA)
        else
            charSelect.hud_hide_element(HUD_DISPLAY_FLAG_CAMERA)
        end

        local cameraHudStatus = hud_get_value(HUD_DISPLAY_CAMERA_STATUS)

        if cameraHudStatus ~= CAM_STATUS_NONE then
            djui_hud_render_texture(gTextures.camera, x, y, 1, 1)

            if (cameraHudStatus & CAM_STATUS_MODE_GROUP) == CAM_STATUS_MARIO then
                djui_hud_render_texture(k.kSkin.icon, x + 16, y, 1, 1)
            elseif (cameraHudStatus & CAM_STATUS_MODE_GROUP) == CAM_STATUS_LAKITU then
                djui_hud_render_texture(gTextures.lakitu, x + 16, y, 1, 1)
            elseif (cameraHudStatus & CAM_STATUS_MODE_GROUP) == CAM_STATUS_FIXED then
                djui_hud_render_texture(gTextures.no_camera, x + 16, y, 1, 1)
            end

            if (cameraHudStatus & CAM_STATUS_C_MODE_GROUP) == CAM_STATUS_C_DOWN then
                djui_hud_render_texture(gTextures.arrow_down, x + 4, y + 16, 1, 1)
            elseif (cameraHudStatus & CAM_STATUS_C_MODE_GROUP) == CAM_STATUS_C_UP then
                djui_hud_render_texture(gTextures.arrow_up, x + 4, y - 8, 1, 1)
            end
        end
    else
        if charSelectExists == nil then
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_CAMERA)
        else
            charSelect.hud_show_element(HUD_DISPLAY_FLAG_CAMERA)
        end
    end
end

function render_king_zl()
    local gSync = gPlayerSyncTable[0]
    local k = gKingStates[0]

    local x = djui_hud_get_screen_width()/2
    local y = 15

    if gMarioStates[0].action == ACT_INTRO_CUTSCENE
    or (gMarioStates[0].marioObj.activeFlags & ACTIVE_FLAG_ACTIVE) == 0
    or gNetworkPlayers[0].currActNum == 99
    or hud_is_hidden() then
        return
    end

    if gSync.isKing then
        if (hud_get_value(HUD_DISPLAY_FLAGS) & HUD_DISPLAY_FLAG_COIN_COUNT) ~= 0 then
            x = djui_hud_get_screen_width()/3
        end

        if k.starKing.closeToStar and (save_file_get_flags() & SAVE_FLAG_TALKED_TO_KING) ~= 0 then

            if k.starKing.timer > 1200 then
                djui_hud_set_color(127, 127, 127, 127)
            end

            djui_hud_render_texture(TEX_ZL_INPUT, x - TEX_ZL_INPUT.width/2, y - 2, 1, 1)
        end
    end
end

function is_end_screen(m) -- TEMPORARY END SET CODE | FIXED IN V1.1
    if m.action == ACT_END_WAVING_CUTSCENE and m.actionTimer >= 300 then
        lvl_set_current_level(0, LEVEL_ENDING)
    end

    return gNetworkPlayers[0].currLevelNum == LEVEL_ENDING
end

function render_king_end()
    local gSync = gPlayerSyncTable[0]

    local x = djui_hud_get_screen_width()/2 - TEX_CAKE.width/2
    local y = djui_hud_get_screen_height()/2 - TEX_CAKE.height/2

    if is_end_screen(gMarioStates[0]) == false then
        return
    end

    if gSync.isKing then
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(0, 0, djui_hud_get_screen_width(), djui_hud_get_screen_height())
        djui_hud_set_color(255, 255, 255, 255)

        djui_hud_set_filter(FILTER_LINEAR)
        djui_hud_render_texture(TEX_CAKE, x, y, 1, 1)
    end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    local gSync = gPlayerSyncTable[0]

    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_HUD)

    djui_hud_set_color(255, 255, 255, 255)
    render_king_lives()

    djui_hud_set_color(255, 255, 255, 255)
    render_king_camera()

    djui_hud_set_color(255, 255, 255, 255)
    render_king_zl()

    djui_hud_set_color(255, 255, 255, 255)
    render_king_end()

    if gSync.isKing then
        texture_override_set("texture_transition_mario", TEX_TRANSITION)
		texture_override_set("texture_menu_course_upper", TEX_COURSE_UPPER)
		texture_override_set("texture_menu_course_lower", TEX_COURSE_LOWER)
		texture_override_set("texture_power_meter_left_side", TEX_POWER_L)
		texture_override_set("texture_power_meter_right_side", TEX_POWER_R)
	else
        texture_override_reset("texture_transition_mario")
		texture_override_reset("texture_menu_course_upper")
		texture_override_reset("texture_menu_course_lower")
		texture_override_reset("texture_power_meter_left_side")
		texture_override_reset("texture_power_meter_right_side")
	end
end)